"""
author Daniel Riegelhaupt

atom3 constraints for the connection
*cannot conenct to self
*cannot conenct same pieces twice (whatever the direction of the conenction is)
"""
def isGate(piece):
	name = piece.__class__.__name__
	return ((name == "p_gate") or (name == "n_gate"))

def connectedConstraint(gate):
	
	assocs = gate.in_connections_
	for assoc in assocs:
		startGates = assoc.in_connections_
		for startGate in startGates:
			if isGate(startGate):
				if startGate == gate:
					return ("cannot connect gate to self", gate)
				else:		
					#look to see if there are 2 arrow starting from the same start gate two here 
					total = 0
					assocs2 = startGate.out_connections_
					for assoc2 in assocs2:
						endGates = assoc2.out_connections_
						for endGate in endGates:
							if endGate == gate:
								total = total+1
					if total > 1:
						return ("those gates are already connected", gate)
						
					#look to see if there is an arrow form the gate going to the start gate already
					
					assocs3 = gate.out_connections_
					for assoc3 in assocs3:
						startGates2 = assoc3.out_connections_
						for startGate2 in startGates2:
							if isGate(startGate2):
								if startGate2 == startGate:
									return ("those gates are already connected (the other way)", gate)
																				
	return None

